Package com.saxonica.ee.stream.om

## Class FleetingNode

- java.lang.Object
- - com.saxonica.ee.stream.om.FleetingNode

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `FleetingParentNode`

      public class FleetingNode
      extends java.lang.Object
      implements NodeInfo

  A FleetingNode is a node that exists transiently in the course of streaming processing. The node has a parent (unless it is the root), and the case of an element node it also has attributes and namespaces. If it is a "remembered ancestor" then it may have descendants, but these cannot be found using the descendant axis. It has no following or preceding nodes.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected FleetingDocumentNode` | `root` |

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FleetingNode()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicSequence` | `atomize()` | Get the typed value.
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `boolean` | `equals​(java.lang.Object other)` | Determine whether this is the same node as another node.
    `void` | `generateId​(FastStringBuffer buffer)` | Construct a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `java.lang.String` | `getBaseURI()` | Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `Configuration` | `getConfiguration()` | Get the configuration used to build the tree containing this node.
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace declarations and undeclarations defined on this element.
    `int` | `getDepth()` | Get the depth of this node in the tree.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node, in the form of a lexical QName.
    `int` | `getFingerprint()` | Get fingerprint.
    `NamespaceMap` | `getInScopeNamespaces()` | Get all in-scope namespaces defined on this element.
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `NamePool` | `getNamePool()` | Get the NamePool that holds the namecode for this node
    `int` | `getNodeKind()` | Get the kind of node.
    `NodeName` | `getNodeName()` |
    `int` | `getNodeNumber()` | Get the serial number of this node within the containing document
    `NodeInfo` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix of the name of the node.
    `NodeInfo` | `getRoot()` | Get the root node of the tree containing this node
    `SchemaType` | `getSchemaType()` | Get the type annotation of this node, if any.
    `java.lang.String` | `getStringValue()` | Return the string value of the node as defined in the XPath data model.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the string value of the item as a CharSequence.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool.
    `NodeInfo` | `head()` | To implement `Sequence`, this method returns the item itself
    `boolean` | `isStreamed()` | Ask whether this is a node in a streamed document
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setNodeKind​(int nodeKind)` |
    `void` | `setNodeName​(NodeName name)` |
    `void` | `setParent​(FleetingNode parent)` |
    `void` | `setStringValue​(java.lang.CharSequence stringValue)` |
    `void` | `setSystemId​(java.lang.String systemId)` | Set the system identifier for this Source.
    `void` | `setTypeAnnotation​(SchemaType typeAnnotation)` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `attributes, children, children, copy, getColumnNumber, getGenre, getLineNumber, getPublicId, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Field Detail

    - #### root

          protected FleetingDocumentNode root

  - ### Constructor Detail

    - #### FleetingNode

          public FleetingNode()

  - ### Method Detail

    - #### head

          public NodeInfo head()

      To implement `Sequence`, this method returns the item itself
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Item`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        this item

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### getDepth

          public int getDepth()

      Get the depth of this node in the tree.
      Returns:
        0 for the document node, 1 for the outermost element, etc

    - #### getNodeNumber

          public int getNodeNumber()

      Get the serial number of this node within the containing document
      Returns:
        the serial number of this node: this reflects document order.

    - #### setParent

          public void setParent​(FleetingNode parent)

    - #### setNodeName

          public void setNodeName​(NodeName name)

    - #### setNodeKind

          public void setNodeKind​(int nodeKind)

    - #### setStringValue

          public void setStringValue​(java.lang.CharSequence stringValue)

    - #### setTypeAnnotation

          public void setTypeAnnotation​(SchemaType typeAnnotation)

    - #### getNodeKind

          public final int getNodeKind()

      Get the kind of node. This will be a value such as `Type.ELEMENT` or `Type.ATTRIBUTE`. There are seven kinds of node: documents, elements, attributes, text, comments, processing-instructions, and namespaces.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        an integer identifying the kind of node. These integer values are the same as those used in the DOM
      Since:
        8.4
      See Also:
        `Type`

    - #### equals

          public final boolean equals​(java.lang.Object other)

      Determine whether this is the same node as another node.

      Note that two different NodeInfo instances can represent the same conceptual node. Therefore the "==" operator should not be used to test node identity. The equals() method should give the same result as isSameNodeInfo(), but since this rule was introduced late it might not apply to all implementations.

      Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b).

      This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.

      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the System ID for the node. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot. The base URI is used primarily for resolving relative URIs within the content of the document. The system ID is used primarily in conjunction with a line number, for identifying the location of elements within the source XML, in particular when errors are found. For a document node, the System ID represents the value of the document-uri property as defined in the XDM data model.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.
      Since:
        8.4

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used. Where the node does not have a base URI of its own, the base URI of its parent node is returned.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown.
      Since:
        8.4

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### compareOrder

          public final int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order.

      The other node must always be in the same tree; the effect of calling this method when the two nodes are in different trees is undefined. To obtain a global ordering of nodes, the application should first compare the result of getDocumentNumber(), and only if the document number is the same should compareOrder() be called.

      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())
      Since:
        8.4

    - #### getStringValue

          public final java.lang.String getStringValue()

      Return the string value of the node as defined in the XPath data model.

      The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

      This method returns the string value as if the node were untyped. Unlike the string value accessor in the XPath 2.0 data model, it does not report an error if the element has a complex type, instead it returns the concatenation of the descendant text nodes as it would if the element were untyped.

      Specified by:
        `getStringValue` in interface `GroundedValue`
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Returns:
        the string value of the node
      Since:
        8.4
      See Also:
        `Item.getStringValueCS()`

    - #### hasFingerprint

          public boolean hasFingerprint()

      Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool. If the answer is true, then the `getFingerprint()` method must return the fingerprint of the node. If the answer is false, then the `getFingerprint()` method should throw an `UnsupportedOperationException`. In the case of unnamed nodes such as text nodes, the result can be either true (in which case getFingerprint() should return -1) or false (in which case getFingerprint may throw an exception).
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.
      Since:
        9.8; previously Saxon relied on using `FingerprintedNode` as a marker interface.

    - #### getFingerprint

          public final int getFingerprint()

      Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. The fingerprint contains no information about the namespace prefix. For a name in the null namespace, the fingerprint is the same as the name code.
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      Since:
        8.4

    - #### getNodeName

          public final NodeName getNodeName()

    - #### getLocalPart

          public final java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "". Unlike the DOM interface, this returns the full name in the case of a non-namespaced name.
      Since:
        8.4

    - #### getURI

          public final java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for an element or attribute that is not in a namespace, or for a processing instruction, returns an empty string.
      Since:
        8.4

    - #### getDisplayName

          public final java.lang.String getDisplayName()

      Get the display name of this node, in the form of a lexical QName. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, returns an empty string.
      Since:
        8.4

    - #### getPrefix

          public final java.lang.String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, returns a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.
      Since:
        8.4

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration used to build the tree containing this node.
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Returns:
        the Configuration
      Since:
        8.4

    - #### getNamePool

          public NamePool getNamePool()

      Get the NamePool that holds the namecode for this node
      Returns:
        the namepool
      Since:
        8.4

    - #### getSchemaType

          public final SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Specified by:
        `atomize` in interface `Item`
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value. This will either be a single AtomicValue or a Value whose items are atomic values.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content

    - #### getParent

          public final NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        the parent of this node; null if this node has no parent

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - an integer identifying the axis; one of the constants defined in class `AxisInfo`
        `nodeTest` - A condition to be satisfied by the returned nodes; nodes that do not satisfy this condition are not included in the result
      Returns:
        an AxisIterator that delivers the nodes reached by the axis in turn. The nodes are returned in axis order (document order for a forwards axis, reverse document order for a reverse axis).
      Throws:
        `java.lang.UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of the tree containing this node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node. If this node has no parent, then the method returns this node.
      Since:
        8.4

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `iterateAxis(Axis.CHILD).next() != null`

      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        True if the node has one or more children
      Since:
        8.4

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Construct a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer which will be updated to hold a string that uniquely identifies this node, across all documents.
      Since:
        8.7

        Changed in Saxon 8.7 to generate the ID value in a client-supplied buffer

    - #### getInScopeNamespaces

          public NamespaceMap getInScopeNamespaces()

      Get all in-scope namespaces defined on this element.
      Returns:
        a `NamespaceMap` containing all the in-scope namespaces for an element (not just those declared locally on the element itself). Returns null if the node is not an element.

    - #### isStreamed

          public boolean isStreamed()

      Ask whether this is a node in a streamed document
      Specified by:
        `isStreamed` in interface `Item`
      Specified by:
        `isStreamed` in interface `NodeInfo`
      Returns:
        true if the node is in a document being processed using streaming

    - #### setSystemId

          public void setSystemId​(java.lang.String systemId)

      Set the system identifier for this Source.

      The system identifier is optional if the source does not get its data from a URL, but it may still be useful to provide one. The application can use a system identifier, for example, to resolve relative URIs and to include in error messages and warnings.

      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`
      Parameters:
        `systemId` - The system identifier as a URL string.

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the string value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String. The method satisfies the rule that `X.getStringValueCS().toString()` returns a string that is equal to `X.getStringValue()`.

      Note that two CharSequence values of different types should not be compared using equals(), and for the same reason they should not be used as a key in a hash table.

      If the calling code can handle any CharSequence, this method should be used. If the caller requires a string, the `getStringValue()` method is preferred.

      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      Since:
        8.4
      See Also:
        `getStringValue()`

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Description copied from interface: `NodeInfo`
      Get all namespace declarations and undeclarations defined on this element.

      This method is intended primarily for internal use. User applications needing information about the namespace context of a node should use `iterateAxis(Axis.NAMESPACE)`. (However, not all implementations support the namespace axis, whereas all implementations are required to support this method.)

      In many cases (and in particular with Saxon's TinyTree and LinkedTree implementations), from 10.0 onwards it is more efficient to call `NodeInfo.getAllNamespaces()` to get all the in-scope namespaces at once, rather than building up the list be calling `getDeclaredNamespaces` on each ancestor node.

      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of namespace binding objects representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. If the uri part is "", then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to null.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.